#include <iostream>
#include <vector>

using namespace std;
pair<vector<int>,vector<bool>> a;

bool is_prime(int x) {
	bool ans = true;
	for (int i = 2; i * i <= x; i++) {
		if (x % i == 0) {
			ans = false;
		}
	}
	return ans;
}


int main() {

	int n; cin >> n;
	a.first.resize(n);
	a.second.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a.first[i];
	}

	a.second[0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			a.second[j] = a.second[i];
			if (a.first[i] > a.first[j]) {
				if (is_prime(a.first[i] / a.first[j]) && (a.first[i] / a.first[j]) > 1) {
					a.second[j] = !a.second[i];
				}
			}
			else {
				if (is_prime(a.first[j] / a.first[i]) && (a.first[j] / a.first[i]) > 1) {
					a.second[j] = !a.second[i];
				}
			}
		}
	}

	for (auto i : a.second) {
		if (i)
			cout << "2" << " ";
		else
			cout << "1" << " ";
	}

	return 0;
}