#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;

long long n, m, ans;

vector<long long> a; vector<long long> t;

long long f(long long x) {
	long long s = 0ll;
	for (int i = 0ll; i < n; i++) {
		if (x >= (a[i]+t[i])) {
			s += (1ll << (x - a[i] - t[i] + 1ll));
		}
		if (a[i] <= x && x < (a[i] + t[i])) {
			s += 1ll;
		}
	}
	return s;
}


int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	ans = -1ll;
	cin >> n >> m;
	a.resize(n);
	t.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}

	long long l = 1ll; long long r = INT32_MAX; long long res; long long x = 1000;
	while (x>0) {
		long long mid = (l + r)/2ll;
		res = f(mid);
		if (res > m)
			r = mid;
		if(res <= m)
			l = mid;
		x--;
	}
	if (f(l)==m)
		ans = l;
	cout << ans;
	
	return 0;
}