#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
pair<vector<int>, vector<bool>> a;
bool is_prime(int x) {
	bool ans = true;
	for (int i = 2; i * i <= x; i++) {
		if (x % i == 0) {
			ans = false;
		}
	}
	return ans;
}


int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n; cin >> n;
	a.first.resize(n);
	a.second.resize(n);

	int max_el = 0;
	for (int i = 0; i < n; i++) {
		cin >> a.first[i];
		if (a.first[i] > max_el) {
			max_el = a.first[i];
		}
	}


	if (max_el == 4) {
		for (int i = 0; i < n; i++) {
			if (a.first[i] == 1)
				a.second[i] = 1;
			if (a.first[i] == 2)
				a.second[i] = 0;
			if (a.first[i] == 3)
				a.second[i] = 0;
			if (a.first[i] == 4)
				a.second[i] = 1;
		}
	}
	else {

		vector<int> l; vector<int> r;
		l.push_back(a.first[0]);

		for (int i = 1; i < n; i++) {
			bool flag = false;
			for (int el : l) {
				if (el > a.first[i]) {
					if (is_prime(el / a.first[i]) && el / a.first[i] > 1) {
						r.push_back(a.first[i]);
						a.second[i] = 1;
						flag = true;
					}
				}
				else {
					if (is_prime(a.first[i] / el) && a.first[i] / el > 1) {
						r.push_back(a.first[i]);
						a.second[i] = 1;
						flag = true;
					}
				}
			}
			if (!flag) {
				l.push_back(a.first[i]);
				a.second[i] = 0;
			}
		}
	}
	for (auto i : a.second) {
		if (i)
			cout << "2" << " ";
		else
			cout << "1" << " ";
	}

	return 0;
}