#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;

int n, m, ans;

vector<int> a; vector<int> t;

int f(int x) {
	int s = 0;
	for (int i = 0; i < n; i++) {
		if (x >= (a[i]+t[i])) {
			s += (1 << (x - a[i] - t[i] + 1));
		}
		if (a[i] <= x && x < (a[i] + t[i])) {
			s += 1;
		}
	}
	return s;
}


int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	ans = -1;
	cin >> n >> m;
	a.resize(n);
	t.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}

	int l = 0; int r = INT32_MAX; int res;
	while (r - l > 1) {
		int mid = (l + r)/2;
		res = f(mid);
		if (res > m)
			r = mid;
		if(res <= m)
			l = mid;
	}
	if (f(l)==m)
		ans = l;
	cout << ans;
	
	return 0;
}